﻿Imports System.Collections.ObjectModel
Imports Infragistics.Controls.Menus

Class MainWindow

	Private _MainTreeClickNode As XamDataTreeNode
	Private _SelectedSubItems As New ObservableCollection(Of clsSubItem)
	Private TreeDataSource As ObservableCollection(Of clsItem)

	Public Sub New()

		' This call is required by the designer.
		InitializeComponent()

		' Add any initialization after the InitializeComponent() call.
		TreeDataSource = BuildData()
		Me._MenuTree.ItemsSource = TreeDataSource

	End Sub
	Private Function BuildData() As ObservableCollection(Of clsItem)

		Dim SourceList As ObservableCollection(Of  clsItem)

		' Main Item 1
		Dim it1 as new clsItem()
		it1.ID = 1
		it1.ParentID = 0
		it1.Description = "Main Item 1"

		Dim it11 As New clsItem
		it11.ID = 11
		it11.ParentID = 1
		it11.Description = "Main Item 11"

		Dim it111 As New clsItem
		it111.ID = 111
		it111.ParentID = 11
		it111.Description = "Main Item 111"
		Dim ita1 as new clsSubItemA 
		ita1.ID = 91
		ita1.Code = "Type A 91"
		ita1.Description = "A-91"
		it111.SubItem = ita1

		Dim it910 as New clsItem
		it910.ID = 910
		it910.ParentID = 111
		it910.Description = "Main Item 91  - independent node"
		Dim itb9100 as new clsSubItemB
		itb9100.ID = 9100
		itb9100.Code = "Type B 91"
		itb9100.Description = "B-91"
		it910.SubItem = itb9100
		dim it920 as New clsItem
		it920.ID = 920
		it920.ParentID = 111
		it920.Description = "Main Item 92  - independent node"
		Dim itb9200 as new clsSubItemB 
		itb9200.ID = 9200
		itb9200.Code = "Type B 92"
		itb9200.Description = "B-92"
		it920.SubItem = itb9200

		it111.ChildItems = new ObservableCollection(Of clsItem)
		it111.ChildItems.Add(it910)
		it111.ChildItems.Add(it920)

		it11.ChildItems = new ObservableCollection(Of clsItem)
		it11.ChildItems.Add(it111)

		it1.ChildItems = new ObservableCollection(Of clsItem)
		it1.ChildItems.Add(it11)

		SourceList = new ObservableCollection(Of clsItem) 
		SourceList.Add(it1)

		' Main Item 12
		' Main Item 1
		Dim it2 as new clsItem()
		it2.ID = 2
		it2.ParentID = 0
		it2.Description = "Main Item 2"

		Dim it21 As New clsItem
		it21.ID = 21
		it21.ParentID = 2
		it21.Description = "Main Item 21"

		Dim it211 As New clsItem
		it211.ID = 211
		it211.ParentID = 21
		it211.Description = "Main Item 211"
		Dim ita2 as new clsSubItemA 
		ita2.ID = 81
		ita2.Code = "Type A 81"
		ita2.Description = "A-81"
		it211.SubItem = ita2

		Dim it810 as New clsItem
		it810.ID = 810
		it810.ParentID = 111
		it810.Description = "Main Item 810  - independent node"
			Dim itb8100 as new clsSubItemB
			itb8100.ID = 8100
			itb8100.Code = "Type A 81"
			itb8100.Description = "A-81"
			it810.SubItem = itb8100
		dim it820 as New clsItem
		it820.ID = 920
		it820.ParentID = 111
		it820.Description = "Main Item 820  - independent node"
			Dim itb8200 as new clsSubItemB 
			itb8200.ID = 8200
			itb8200.Code = "Type B 82"
			itb8200.Description = "B-82"
			it820.SubItem = itb8200

		it211.ChildItems = new ObservableCollection(Of clsItem)
		it211.ChildItems.Add(it810)
		it211.ChildItems.Add(it820)

		it21.ChildItems = new ObservableCollection(Of clsItem)
		it21.ChildItems.Add(it211)

		it2.ChildItems = new ObservableCollection(Of clsItem)
		it2.ChildItems.Add(it21)

		SourceList.Add(it2)

		'Dim it3 As New clsItem
		'it3.ID = 12
		'it3.ParentID = 1
		'it3.Description = "Main Item One - Two"


		return SourceList

	End Function
	Private Sub TreeNodeCheckedChanged(InSender As Object, InEventArgs As NodeEventArgs)

		Try
			Dim menuItem As clsItem
			Dim tranCount As Integer

			' We do not want any changes to be done, if the input was not user action.
			'If Not _SyncFromGrid Then

			If _MainTreeClickNode IsNot Nothing Then
				Me.Cursor = Cursors.Wait
			End If

			menuItem = DirectCast(InEventArgs.Node.Data, clsItem)
			If Not menuItem.SubItem Is Nothing Then
				If Nullable.Equals(InEventArgs.Node.IsChecked, False) Then
					' Remove from _SelectedSubItems
				Else
					' Add to _SelectedSubItems
				End If
				' Find the duplicate trancode and update that status as well
			End If
			'End If
		Finally
			If _MainTreeClickNode IsNot Nothing AndAlso _MainTreeClickNode.Equals(InEventArgs.Node) Then
				Me.Cursor = Cursors.Arrow
				'Me.BuildSelectedMenuTree()
				'If _MainTreeClickNode.IsChecked Then HighLightNode(InEventArgs.Node, Me._MenuTreeSelected)
			End If
			Me.Cursor = Cursors.Arrow

		End Try

	End Sub

End Class
